module Graph where

import EdisonPrelude
import qualified LeftistHeap as H
import Maybe(fromJust)
import Data.FiniteMap

type Cost = Int
type Graph v = FiniteMap v [v]

dijkstra :: (Ord v) => (v -> v -> Cost) -> Graph v -> v -> v -> Maybe Cost
dijkstra dist g v0 =
    let -- nbhrs :: v -> [v]
	nbhrs v = maybe [] id (lookupFM g v)
	-- processQueue :: (FiniteMap v Cost) -> (H.Heap (v,Cost))
        --     -> (FiniteMap v Cost)
	processQueue m h
          | Just2 (v1,c1) h' <- H.minView h =
	    if elemFM v1 m then processQueue m h' else
	     let nvs = map (\v -> (v, (dist v v1)+c1)) (nbhrs v1)
		 h'' = foldr H.insert h' nvs 
		 m' = addToFM m v1 c1
	     in processQueue m' h''
	  | otherwise = m
	initQueue = H.insert (v0, 0) H.empty
    in lookupFM (processQueue emptyFM initQueue)
